image: docker

services:
  - docker:dind

stages:
  - build
  - deploy
  - cleanup


variables:
  BOT_IMAGE: ${CI_REGISTRY_IMAGE}/tg_feed_bot:${CI_COMMIT_REF_SLUG}
  SENDER_IMAGE: ${CI_REGISTRY_IMAGE}/tg_feed_bot_sender:${CI_COMMIT_REF_SLUG}
  SERVICE_NAME: "tg_feed_bot"


before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com


build-bot:
  stage: build
  retry: 1
  script:
    - docker build -t $BOT_IMAGE -f bot/devops/Dockerfile bot
    - docker push $BOT_IMAGE


build-sender:
  stage: build
  retry: 1
  script:
    - docker build -t $SENDER_IMAGE -f sender/devops/Dockerfile sender
    - docker push $SENDER_IMAGE


deploy:
  stage: deploy
  environment: production
  variables:
    LOG_LEVEL: "DEBUG"
    DB_HOST: "10.129.0.18"
    DB_PORT: 5432
    DB_NAME: "tg_feed_bot"
    TG_PROXY_URL: "socks5://proxy.itlabs.io"
    RABBITMQ_HOST: "10.129.0.27"
    RABBITMQ_PORT: 5672
    RABBITMQ_VHOST: "/"
    SSH_TARGET: "$TARGET_USER@$TARGET_HOST"
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    # Run ssh-agent (inside the build environment)
    - eval $(ssh-agent -s)
    # Add the SSH key stored in SSH_PRIVATE_KEY variable to the agent store
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - rsync -av -e ssh . $SSH_TARGET:/home/$TARGET_USER/$SERVICE_NAME
    - |
        SSH_CMD=$(cat << EOF
          set -x
          set -e
          echo "as \$USER at \$HOSTNAME"
          cd $SERVICE_NAME
          docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
          export CI_COMMIT_REF_SLUG="$CI_COMMIT_REF_SLUG"
          export BOT_IMAGE="$BOT_IMAGE"
          export SENDER_IMAGE="$SENDER_IMAGE"
          export LOG_LEVEL="$LOG_LEVEL"
          export DB_HOST="$DB_HOST"
          export DB_PORT="$DB_PORT"
          export DB_NAME="$DB_NAME"
          export TG_PROXY_URL="$TG_PROXY_URL"
          export RABBITMQ_HOST="$RABBITMQ_HOST"
          export RABBITMQ_PORT="$RABBITMQ_PORT"
          export RABBITMQ_VHOST="$RABBITMQ_VHOST"
          docker-compose config
          docker-compose up -d
        EOF
        )
    - echo "$SSH_CMD"
    - ssh $SSH_TARGET "$SSH_CMD"
  only:
    - master


cleanup:
  stage: cleanup
  when: always
  allow_failure: true
  variables:
    GIT_STRATEGY: none
  script:
    - docker rmi -f $BOT_IMAGE || true
    - docker rmi -f $SENDER_IMAGE || true
